/*
GLSLFVF[_[؂ւiO[VF[fBOƃtHVF[fBO̔rj
*/
#include <fstream>
#include <string>
#include <iostream>
#include <GL/glew.h>
#include <GL/glut.h>
using namespace std;

int WindowPositionX = 200;  //EBhEʒuXW
int WindowPositionY = 100;  //EBhEʒuYW
int WindowWidth  = 512;     //EBhE̕
int WindowHeight = 512;     //EBhE̍
char WindowTitle[] = "E̎n܂";	//EBhẼ^Cg

//----------------------------------------------------
// VF[_RpC֘A
//----------------------------------------------------
GLuint shaderPrograms[2];       //VF[_vO
/* _obt@IuWFNgID */
#define VERTEX  1
#define FRAGMENT  2

GLuint getShader(const char *file, int type)
{
	GLuint shader;
  if(type == VERTEX)        shader = glCreateShader(GL_VERTEX_SHADER);
  else if(type == FRAGMENT) shader = glCreateShader(GL_FRAGMENT_SHADER);

	ifstream ifs(file);
	istreambuf_iterator<char> vdataBegin(ifs);
	istreambuf_iterator<char> vdataEnd;
	string filedata(vdataBegin,vdataEnd);
	const char *vfile = filedata.c_str();

	glShaderSource(shader, 1, &vfile, NULL);	//\[XR[hVF[_IuWFNgɕϊ
	glCompileShader(shader);                  //RpC

	return shader;
}

void initShaders(){
  //glew̏
  GLenum err = glewInit();
  if (err != GLEW_OK) printf("Error: %s\n", glewGetErrorString(err));
	{
		//VF[_[̓ǂݍ݂ƃRpC
		GLuint vertexShader   = getShader("../../Gouraud.vert", VERTEX);  //Phong or Gouraud
		GLuint fragmentShader = getShader("../../Gouraud.frag", FRAGMENT);

		shaderPrograms[0] = glCreateProgram();  // vOIuWFNg̍쐬 

		glAttachShader(shaderPrograms[0], vertexShader);
		glAttachShader(shaderPrograms[0], fragmentShader);

		glLinkProgram(shaderPrograms[0]);
	}
	{
		//VF[_[̓ǂݍ݂ƃRpC
		GLuint vertexShader   = getShader("../../Phong.vert", VERTEX);  //Phong or Gouraud
		GLuint fragmentShader = getShader("../../Phong.frag", FRAGMENT);

		shaderPrograms[1] = glCreateProgram();  // vOIuWFNg̍쐬 

		glAttachShader(shaderPrograms[1], vertexShader);
		glAttachShader(shaderPrograms[1], fragmentShader);

		glLinkProgram(shaderPrograms[1]);
	}
}

GLuint vertexPositionID, vertexNormalID, vertexIndexID;
void initBuffers(){
	//lp`̃obt@
	GLfloat vertices[][3] = { 
		{-2.5, -2.5, 0.0}, {2.5, -2.5, 0.0}, {2.5,  2.5, 0.0}, {-2.5,  2.5, 0.0}
	};
	GLfloat normals[][3] = {
		{0.0, 0.0, 1.0}, {0.0, 0.0, 1.0}, {0.0, 0.0, 1.0}, {0.0, 0.0, 1.0}
	};
	GLuint indices[6] = {
		0, 1, 2, 0, 2, 3
	};

  glGenBuffers(1, &vertexPositionID); 
	glBindBuffer(GL_ARRAY_BUFFER, vertexPositionID);
  glBufferData(GL_ARRAY_BUFFER, sizeof (vertices), vertices , GL_STATIC_DRAW);

  glGenBuffers(1, &vertexNormalID); 
	glBindBuffer(GL_ARRAY_BUFFER, vertexNormalID);
  glBufferData(GL_ARRAY_BUFFER, sizeof (normals), normals , GL_STATIC_DRAW);

	glGenBuffers(1, &vertexIndexID);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vertexIndexID);
	glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(indices), indices, GL_STATIC_DRAW);
}

//----------------------------------------------------
// ݒ̊֐
//----------------------------------------------------
void initialize(void){
	glClearColor(0.0, 0.0, 0.0, 1.0); //wiF
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	glViewport( 0, 0, WindowWidth, WindowHeight );
	gluPerspective(30.0, (double)WindowWidth/(double)WindowHeight, 0.1, 1000.0); //e@̎̐gluPerspactive(th, w/h, near, far);
}
//--------------------------------------------------------
// AChɌĂяo֐
//--------------------------------------------------------
void idle(){
 glutPostRedisplay(); //glutDisplayFunc()Ps
}
//----------------------------------------------------
// `֐
//----------------------------------------------------
int step=0;
void draw(){
	step++;
	/////////////////////////////////////////////
	// ގ̎w
	/////////////////////////////////////////////
	GLfloat materialEmission[4] = {0.0,      0.0,      0.0,       1.0}; //ːF
	GLfloat materialAmbient[4]  = {0.1745,   0.01175,  0.01175,   1.0}; //F
	GLfloat materialDiffuse [4] = {0.61424,  0.04136,  0.04136,   1.0}; //gUF
	GLfloat materialSpecular[4] = {0.727811, 0.626959, 0.626959,  1.0}; //ʐF
	GLfloat materialShininess[1] = {76.8};                              //ʎw
	glMaterialfv(GL_FRONT, GL_EMISSION,  materialEmission);  //ːF̎w
	glMaterialfv(GL_FRONT, GL_AMBIENT,   materialAmbient);   //F̎w
	glMaterialfv(GL_FRONT, GL_DIFFUSE,   materialDiffuse);   //gUF̎w
	glMaterialfv(GL_FRONT, GL_SPECULAR,  materialSpecular);  //ʐF̎w
	glMaterialfv(GL_FRONT, GL_SHININESS, materialShininess); //ʎw̎w

	glUseProgram(shaderPrograms[0]);

	glPushMatrix();
		glTranslatef(-2.5, 0.0, 0.0);     //sړ
		glRotatef(step , 1.0, 0.0, 0.0);  //]
		glEnableClientState(GL_VERTEX_ARRAY);
		glBindBuffer(GL_ARRAY_BUFFER, vertexPositionID);
		glVertexPointer(3, GL_FLOAT, 0, 0);

		glEnableClientState(GL_NORMAL_ARRAY);
		glBindBuffer(GL_ARRAY_BUFFER, vertexNormalID);
		glNormalPointer(GL_FLOAT, 0, 0);

		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vertexIndexID);
		glDrawElements(GL_TRIANGLES, 6,	GL_UNSIGNED_INT, 0);
	glPopMatrix();

	glUseProgram(shaderPrograms[1]);

	glPushMatrix();
		glTranslatef(2.5, 0.0, 0.0);     //sړ
		glRotatef(step , 1.0, 0.0, 0.0);  //]
		glEnableClientState(GL_VERTEX_ARRAY);
		glBindBuffer(GL_ARRAY_BUFFER, vertexPositionID);
		glVertexPointer(3, GL_FLOAT, 0, 0);

		glEnableClientState(GL_NORMAL_ARRAY);
		glBindBuffer(GL_ARRAY_BUFFER, vertexNormalID);
		glNormalPointer(GL_FLOAT, 0, 0);

		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vertexIndexID);
		glDrawElements(GL_TRIANGLES, 6,	GL_UNSIGNED_INT, 0);
	glPopMatrix();

	glUseProgram(0);
}

void display(void){
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); //obt@̏
	glMatrixMode( GL_MODELVIEW ); //s񃂁[hfr[sɎw
	glLoadIdentity();             //Jgs̏
	/////////////////////////////////////////////
	// _̐ݒ
	/////////////////////////////////////////////
	gluLookAt(             // _̐ݒ
		   0.0, 0.0, 20.0,    // _̈ʒux,y,z;
		   0.0, 0.0, 0.0,    // E̒Sʒu̎QƓ_Wx,y,z
		   0.0, 1.0, 0.0);   // Ȅ̃xNgx,y,z

	/////////////////////////////////////////////
	// ̐ݒ
	/////////////////////////////////////////////
	GLfloat lightAmbient[4] = {1.0,1.0,1.0,1.0};   //̋x
	GLfloat lightDiffuse[4] = {1.0,1.0,1.0,1.0};   //gŰx
	GLfloat lightSpecular[4] = {1.0,1.0,1.0,1.0};  //ʌ̋x
	GLfloat lightPosition[4] = {0.0,0.0,10.0,1.0};  //ʒu
	glEnable(GL_LIGHTING);                             //̗L
	glEnable(GL_LIGHT0);                               //0̗L
	glLightfv( GL_LIGHT0, GL_AMBIENT,  lightAmbient);  //0̊F̎w
	glLightfv( GL_LIGHT0, GL_DIFFUSE,  lightDiffuse);  //0̊gUF̎w
	glLightfv( GL_LIGHT0, GL_SPECULAR, lightSpecular); //0̋ʌF̎w
	glLightfv( GL_LIGHT0, GL_POSITION, lightPosition); //0̌ʒu̎w

	draw();

	glutSwapBuffers(); //glutInitDisplayMode(GLUT_DOUBLE)Ń_uobt@O𗘗p
}

//----------------------------------------------------
// C֐
//----------------------------------------------------
int main(int argc, char** argv){
	glutInit(&argc, argv);                                     //̏
	glutInitWindowPosition(WindowPositionX, WindowPositionY);  //EBhËʒu̎w
	glutInitWindowSize(WindowWidth, WindowHeight);             //EBhETCY̎w
	glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE); //fBXvC[h̎w
	glutCreateWindow(WindowTitle);                             //EBhE̍쐬
	glutDisplayFunc(display);                                  //`掞ɌĂяo֐w肷i֐Fdisplayj
	glutIdleFunc(idle);                                        //vOAChԎɌĂяo֐
  initShaders();
	initBuffers();
	initialize();                                              //ݒ̊֐Ăяo
	glutMainLoop();
}
